<template>
  <div>
    <div>
<CModal
           title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>Trace Hold </h5>
       <form class="form-inline">
  
   <h6> Barcode</h6>
  <div class="form-group mx-sm-2 mb-2">
    
   <input v-model="searchid">
   
  </div>  
  
  
   <CButton size="sm" color="dark" class="ml-1" @click="getAllHoldDetails(searchid);"> Search </CButton>
  
</form>
    <!-- <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="5"
      pagination
      hover
      striped
      border
     >
   

Adding Customs buttons to each row 
    <template #show_details="{item}" >      
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectMaterial(item)"> Details </CButton>
    </template>

    </CDataTable> -->
      <!-- <CButton size="sm" color="info" class="" @click="ShowAddModal=true"> Add New Material</CButton> -->
  </CCardBody>

 </div>


<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog  modal-lg" >
<div class="modal-content">
  <div class="modal-header" >    
    <h5 class="modal-title">Hold Tread </h5>
      <span> </span>
    
   <h6 class="modal-title">- QA/Technical User Name / Id</h6>
    <button type="button" class="close"  @click="ShowDetailsModal=false;location.reload();">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body modal-lg">

<form >



  <div>
        <!-- <CListGroupItem href="#" color="secondary"> -->
    <CRow>
       <CCol sm="2" > Tread Code</CCol>
      <CCol sm="3">
        <CInput
          readonly
          v-model = this.items.material_Code
        />
      </CCol>
       <CCol sm="2" >Color Code</CCol>
      <CCol sm="3">
        <CInput
          readonly
          v-model = this.items.size_Code
        />
      </CCol>
    </CRow>

     <CRow>
       <CCol sm="2" >Leaf Truck</CCol>
      <CCol sm="3">
        <CInput
          readonly
         v-model = this.items.mhename
        />
      </CCol>
       <CCol sm="2" >Truck Number</CCol>
      <CCol sm="3">
        <CInput
          readonly
         v-model = this.items.truckNumber
        />
      </CCol>
    </CRow>
      <CRow>
      
      <CCol sm="2" > Hold By</CCol>
      <CCol sm="3">
        <CInput
         
         v-model  = newHoldEntry.hold_By
        />
      </CCol>
          <CCol sm="2" >Quantity</CCol>
      <CCol sm="3">
        <CInput
         placeholder = this.items.quantity 
          v-model = newHoldEntry.quantity
        />
      </CCol>
    </CRow>


       <CRow>
      
   
    </CRow>
       <CRow>
   
      <!-- <CCol sm="2" >  Ageing Period</CCol>
      <CCol sm="3">
        <CInput
         readonly
         v-model   = this.Currentproductiondetails.ageing_Time
        />
      </CCol> -->
 <!-- <CCol sm="1" > Age</CCol>
      <CCol sm="5">
        <CInput
          readonly
         v-model= this.items.currentAge
        />
      </CCol> -->
    </CRow>
        <CRow>
           <CCol sm="6">
              </CCol>
           <!-- <CCol sm="2">
        <CInput
         readonly
        v-model   = this.items.ageStatus
        />
      </CCol> -->
     
     
    </CRow>
      <CListGroupItem href="#" color="secondary">
   <CRow>
       
        <CCol sm="2" >Hold Reason</CCol>
        <CCol sm="3">
         <select class="form-control"  v-model="newHoldEntry.hold_Reason_Id" >   
    <option v-for="item in Reasonitems"  :value="item.hold_Reason_Id" :key="item.hold_Reason">{{ item.hold_Reason }} </option>
       </select>

      </CCol>
      
         <CCol sm="2">
        <CButton size="sm" color="warning" class="ml-1" @click="ValidateHoldReason();">Hold Print</CButton>
         </CCol>
          
    <CCol sm="2">
          </CCol>
        <CCol sm="2">
          
      </CCol>
     
    </CRow>
     </CListGroupItem> 
  </div>

</form>

</div>
</div>
</div>
</div>

</div>
</template>

<script>
const items = [


             { key: 'hold_Id' , label: 'hold_Id',_classes: 'font-weight-bold'},
              { key: 'production_ID', label: 'Production Id',_classes: 'font-weight-bold' },
              { key: 'colorcode', label: 'Color Code', _classes: 'font-weight-bold' },             
              //{ key: 'crewDetails',  label: 'crewDetails',  _style: 'width:12%', },
//{ key: 'colorCode',  label: 'colorCode',  _style: 'width:12%', },
              { key: 'ltnumber',  label: 'MHE Id',  _style: 'width:12%', },
              { key: 'quantity',  label: 'Quantity',  _style: 'width:12%', },
 ] 
 const apitag =  'Trace_Tag_Generation/'  
const apiupdate = 'Trace_Production/'
const apihold =  'Trace_Hold/'
const apiget =  'Trace_Production/GetTrace_HoldProductionForBarcode/'
const apiholdreason =  'Trace_Hold_Reasons/'
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
   //components: { CTableWrapper },
  data ()
  {
     return {
    items: items.map((item, id) => { return {...item, id}}),
    
     fields: [
       // { key: 'show_details1',  label: '',  _style: 'width:1%', },
            
              { key: 'hold_Id' , label: 'hold_Id',_classes: 'font-weight-bold'},
              { key: 'production_ID', label: 'Production Id',_classes: 'font-weight-bold' },
              { key: 'colorcode', label: 'Color Code', _classes: 'font-weight-bold' },             
              //{ key: 'crewDetails',  label: 'crewDetails',  _style: 'width:12%', },
            //  { key: 'colorCode',  label: 'colorCode',  _style: 'width:12%', },
              { key: 'ltnumber',  label: 'MHE_Id',  _style: 'width:12%', },
               { key: 'quantity',  label: 'Quantity',  _style: 'width:12%', },

             // { key: 'hold_Status',  label: 'hold_Status',  _style: 'width:12%', },
                 { key: 'show_details',  label: '',  _style: 'width:1%', },
      ],
   searchid:"",  
   Reasonitems:[],
  details: [],
  collapseDuration: 0,
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentMaterial:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  holdreasonName:"",
  holdreason:[],
  Barcode :"",
  BarcodeId :0,
 newTag:{inv_TransId : 0,   tagId: 0, productionId:0, location_Id: 0,  printer_Name: "",  printer_Ip: "",  printed_DateTime: "",  module_Name: " ", barcodeId:0, user_Id: 0, no_Of_Copies:1, print_Status: 1,tagDetails: {}},

  CurrentEntry:[],
  newHoldEntry: {hold_Id:0,production_ID:"",hold_Reason_Id:0,hold_By:"",hold_Time:new Date(),hold_Date:new Date(),hold_Status:1, barcodeId :0,quantity:0,holdreason:""}, }
  },
 

  
  mounted()
  {
  this.getAllReasonitemsDetails();
  //  this.getAllHoldDetails();
  },

  methods:
  {
   getAllHoldDetails: function(searchid)
   { 
     
 
   Vue.axios.get(this.$url + apiget + searchid)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
      else if(response.data[0].length == 0)
     {
       //alert(response.data[0].length)
     this.SuccessMsg = "No Data Available for searched Barcode"
      this.smallModal = true;
      //this.ShowDetailsModal =  false;

     }
    else
       {
    // alert("in")
      this.items =response.data[0];
      this.ShowDetailsModal = true; 
  // console.log(response.data);
       }
    });
   },

   getAllReasonitemsDetails: function()
   {

   Vue.axios.get(this.$url+apiholdreason)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
       
        this.Reasonitems = response.data.filter(x => x.hold_Reason_status = 1);     

       }
    });
   },

  addToHold()
  {


     this.newHoldEntry.production_ID =  this.items.production_Id,
     this.newHoldEntry.hold_Reason_Id = this.newHoldEntry.hold_Reason_Id,
    this.newHoldEntry.barcodeId = this.items.barcode_Id,
     this.newHoldEntry.hold_By = this.newHoldEntry.hold_By,
     this.newHoldEntry.hold_Time = new Date().toLocaleTimeString() ,
     this.newHoldEntry.hold_Date = new Date().toISOString().slice(0,10),
     this.newHoldEntry.quantity = this.newHoldEntry.quantity;
     this.holdreason = this.Reasonitems.filter(x => x.hold_Reason_Id == this.newHoldEntry.hold_Reason_Id); 
     this.holdreasonName = this.holdreason[0].hold_Reason;
      this.newHoldEntry.holdreason  = this.holdreasonName;
     if ( this.items.prod_Status == 1)
     { 
       Vue.axios.put(this.$url + apihold , this.newHoldEntry).then((response)=>{
    //Vue.axios.put(this.$url+ apihold,this.newHoldEntry).then((response)=>{
     //alert(response.data)
       if(response.data.error)
       {
          alert('Data Error')
       }
       else if(response.data == 1)
       {
         
      this.SuccessMsg = "Hold Tag generation already done for this item",
     this.smallModal = true;

       }
       else
       {
           this.SuccessMsg ="Tread Status Updated to Hold  "
          this.smallModal = true;
          this.ShowDetailsModal = false;
         this.addToTagGeneration(1);
             location.reload();
       }
    })
     }
     else if( this.items.prod_Status == 3) 
     {
 
  Vue.axios.post(this.$url + apihold, this.newHoldEntry).then((response)=>{
    //Vue.axios.put(this.$url+ apihold,this.newHoldEntry).then((response)=>{
     
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
           this.SuccessMsg ="Tread Status Updated to Hold  "
          this.smallModal = true;
          this.ShowDetailsModal = false;
          
         this.addToTagGeneration(1);
         location.reload();
       }
    })

     }
    //}
    

   },
 addToTagGeneration(status)
  {

    if(status == 1)
    {
      
        this.newTag.module_Name = "DUALHOLD"
        this.holdreason = this.Reasonitems.filter(x => x.hold_Reason_Id == this.newHoldEntry.hold_Reason_Id); 
        this.holdreasonName = this.holdreason[0].hold_Reason
      // alert( " HoldReason" +this.holdreasonName )

    }

   this.newTag.barcodeId = this.BarcodeId,
    this.newTag.printer_Name= "canon", 
    this.newTag.printer_Ip= "192.168.1.12", 
    this.newTag.printed_DateTime=  new Date(),
    this.newTag.print_Status= 0,
    this.newTag.location_Id=1,
     this.newTag.user_Id =  this.newHoldEntry.hold_By,
    this.newTag.tagDetails =  " Barcode : " + this.searchid + "|| Code : "+ this.items.colorcode + "|| Tread : "+ this.items.materialcode+ "|| DUAL: DUAL"+ this.items.workCent_Id + "|| Nos : " + this.newHoldEntry.quantity  +"|| Operators : "+ this.items.crewDetails +"/" + this.items.remarks +"|| LT No :" +this.items.mhE_Id  +"|| TruckNo :" +this.items.truckNumber+"|| ProdDate :" + this.items.prod_Date +"|| shift_Id :" + this.items.shift_Id + " ||Compound Code :" +this.items.comp_Code + "|| PrintTime - " + new Date().toLocaleTimeString()+ "|| HoldReason - " +  this.holdreasonName,
  //  this.newTag.no_Of_Copies = this.newMaterial.no_Of_Copies,
//alert(this.newTag.tagDetails)
  Vue.axios.post(this.$url + apitag , this.newTag).then((response)=>{

       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        this.SuccessMsg ="Hold Tag Printing in progress..",
      
       this.smallModal = true;
         this.ShowDetailsModal = true;
       // getAllMaterialDetails();
        
       }
       
    })
  },
ValidateHoldReason()
{

  // if(this.newHoldEntry.quantity > this.items.quantity)
  // {
  // this.SuccessMsg = "Entered Barcode has only " + this.items.quantity + " treads.Kindly check the Quantity. ";
  // this.smallModal =  true;
  // this.ShowDetailsModal = true;
  // }
  if(this.newHoldEntry.hold_Reason_Id == 0)
  {

this.SuccessMsg = "Please select a Hold reason";
this.smallModal =  true;
this.ShowDetailsModal = true;
  }
    if(this.newHoldEntry.hold_Reason_Id == null)
  {

this.SuccessMsg = "Please select a Hold reason";
this.smallModal =  true;
this.ShowDetailsModal = true;
  }
  if(this.newHoldEntry.quantity == 0)
  {
this.SuccessMsg = "Enter Quantity to hold ";
this.smallModal =  true;
this.ShowDetailsModal = true;
  }

   if(this.newHoldEntry.hold_By.length != 6 )
   {this.SuccessMsg = "Enter 6 digit employee code ";
this.smallModal =  true;
this.ShowDetailsModal = true;

   }

  if( this.newHoldEntry.hold_Reason_Id >= 1 && this.newHoldEntry.hold_By >= 1 && this.newHoldEntry.quantity >= 1  && this.newHoldEntry.hold_By.length == 6)// && this.newHoldEntry.quantity < this.items.quantity) 
  {
    this.addToHold();
    

  }
 
},

// validatequantity()
// {

// if(this.newHoldEntry.quantity > this.items.quantity)
// this.SuccessMsg = "Entered Barcode has only " + this.items.quantity + " treads.Kindly check the number. ";
// this.smallModal =  true;
// this.ShowDetailsModal = true;

// },

updateProductionForOkToHold()
{


//alert(this.items.prod_Status)

  if(this.items.prod_Status == 3)
  {
      this.items.prod_Status = 1;
       Vue.axios.put(this.$url+ apiupdate + this.items.production_Id,this.items).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
         this.SuccessMsg ="Item Status changed to hold Successfully.."
         this.smallModal = true;
        // this.getAllStatusDetails();
       }
    })
    }
},

    
    },
  
    

}
</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>